
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>详解使用功能开关更好地实现持续部署 / iVAN</title>

    <meta name="description" content="详解使用功能开关更好地实现持续部署 为了快速发布开发完成的功能,现代的互联网企业通常会以比较快的迭代周期来持续的发布.但是有时候因为技术或者 业务上的原因,需要在发布的时候将某些功能隐藏起来.一种解决方案是,在独立的分支上开发新功能,全部开发测试完成 之后,才合并回主干,准备发布.这也就是我们经常提到的功能分支(feature branch).本文将介绍如何使用功能开关( feature toggle)来更好地解决这个问题,及其在一个典型Spring web应用程序中的具体实现,最后讨论了功能开关和持续 集成如何协同工作. 功能分">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">详解使用功能开关更好地实现持续部署</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>为了快速发布开发完成的功能，现代的互联网企业通常会以比较快的迭代周期来持续的发布。但是有时候因为技术或者 业务上的原因，需要在发布的时候将某些功能隐藏起来。一种解决方案是，在独立的分支上开发新功能，全部开发测试完成 之后，才合并回主干，准备发布。这也就是我们经常提到的功能分支（feature branch）。本文将介绍如何使用功能开关（ feature toggle）来更好地解决这个问题，及其在一个典型Spring web应用程序中的具体实现，最后讨论了功能开关和持续 集成如何协同工作。</p>
<p>功能分支的问题</p>
<p>功能分支可以帮助我们同时开发多个新功能，而不对发布的节奏造成影 响，这解决我们一开始提到的那个持续发布的需求，但是它也会引入很多问题。在Martin Fowler的文章中已经很全面的阐 述了这些问题，简单总结如下：</p>
<p>分支分出去时间长了往主干合并的时候会出现很多的代码冲突。</p>
<p>在一个分支中修改了函数名字，但是如果在其它分支中大量使用修改前的函数名，则会引入大量编译错误。这点被称为 语义冲突（semantic conflict）</p>
<p>为了减少语义冲突，会尽量少做重构。而重构是持续改进代码质量的手段。如果在开发的过程中持续不断的存在功能分 支，就会阻碍代码质量的改进。</p>
<p>一旦代码库中存在了分支，也就不再是真正的持续集成了。当然你可以给每个分支建立一个对应的CI，但它只能测试当 前分支的正确性。如果在一个分支中修改了函数功能，但是在另一个分支还是按照原来的假设在使用，在合并的时候会引入 bug，需要大量的时间来修复这些bug。</p>
<p>功能开关</p>
<p>下面我们来看看功能开关是如何解决上述的问题的。</p>
<p>第一原则，代码库中不再引入任何分支， 所有的代码都提交到同一个主线（mainline），在开始开发一个新功能的时候，引入一个布尔值的配置项，使得在该配置项 为假时，应用程序的外部行为和没有引入该功能之前保持一致；而在配置项为真时，应用程序才展现出那些新开发的功能。</p>
<p>实现的方式也很直观。在所有跟该功能相关的代码中都会读取该配置项的值，如果配置项值为真，则使用新功能， 如果为假，则保持以前的逻辑。我们把在某处代码使用到该布尔配置项称为该处代码使用了该开关。</p>
<p>对于一个典型 的Spring的web项目，代码库中会包括Java代码、JSP代码，IOC配置文件，还有CSS和JS文件。这些都是代码，根据不同的业 务需求，这些代码都有可能会用到开关。为了能够在这些代码中方便地获取开关的值，使用开关，我们需要一些基础设施来 支持。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2g0Lm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vNF8xMzEwMDUxMjI1MjhfMS5qcGc=.jpg"></p>
<p>如上图所示。需要在“功能开关”的模块中实现所需要的基础设施，然后配合配置文件的内容来对应用程序的行为进行 控制。下面我们就配置文件和基础设施做一些讨论。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-22 18:20:26</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%8a%9f%e8%83%bd/" title="功能">功能</a>, <a href="https://www.iamivan.net/tag/%e4%b8%80%e4%b8%aa/" title="一个">一个</a>, <a href="https://www.iamivan.net/tag/%e4%bb%a3%e7%a0%81/" title="代码">代码</a>, <a href="https://www.iamivan.net/tag/%e9%85%8d%e7%bd%ae/" title="配置">配置</a>, <a href="https://www.iamivan.net/tag/%e5%88%86%e6%94%af/" title="分支">分支</a>, <a href="https://www.iamivan.net/tag/%e5%bc%80%e5%8f%91/" title="开发">开发</a>, <a href="https://www.iamivan.net/tag/%e5%8a%9f%e8%83%bd%e4%bb%a3%e7%a0%81/" title="功能代码">功能代码</a>, <a href="https://www.iamivan.net/tag/%e5%8a%9f%e8%83%bd%e5%bc%80%e5%85%b3/" title="功能开关">功能开关</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>详解使用功能开关更好地实现持续部署的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZOBw4b.html" rel="bookmark">Cacti&plus;Nagios应用详解（一）cacti与rrdtool的安装部署</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Cacti与rrdtool简介 一.概述 Linux下用的最多的是MRTG的性能监视,MRTG配置比较简单,MRTG的确是非常好的东东,但我认为它毕竟已经是一套很旧的软件了,其作者在多年前就已经开发了RRDTool代替该软件,现在已经发展得很成熟.既然有更好的选择,为什么我们还要用MRTG呢? 简单的说,rrdtool就是一个强大的绘图的引擎,很多语言都可以调用rrdtool绘图. 整个系统的架构是这样的: 基于SNMP协议,被监控端是服务器,或一些网络设备, 网络管理工作站,采用Linux(或			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwlJXnb.html" rel="bookmark">Cacti&plus;Nagios应用详解（二）整合cacti与nagios安装部署</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Nagios简介 Nagios是一个用来监视系统和网络的开源应用软件,它通常运行于一个主服务器上,这个服务器运行 Liunx 或 Unix 操作系统.Nagios 利用其众多的插件实现对本机和远端服务的监控,当被监控对象出现异常,Nagios 就会及时给管理人员告警.它是一个基于TCP/IP协议的软件包,包含有nagios主程序和它的各个插件,配置非常灵活,可以监视的项目很多,也可以通过自定义 shell 脚本进行监控服务,非常适合各类企业的网络应用. Nagios功能非常强大,它可以监控服务和			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MW7x4GM.html" rel="bookmark">详解Nginx &plus; Tomcat 反向代理 负载均衡 集群 部署指南&lowbar;nginx</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Nginx是一种服务器软件,也是一种高性能的http和反向代理服务器,同时还是一个代理邮件服务器.也就是说,我们在Nginx上可以发布网站,可以实现负载均衡(提高应答效率,避免服务器崩溃),还可以作为邮件服务器实现收发邮件等功能.而最常见的就是使用Nginx实现负载均衡. Nginx与其他服务器的性能比较: Tomcat服务器面向Java语言,是重量级的服务器,而Nginx是轻量级的服务器.Apache服务器稳定.开源.跨平台,但是Apache服务器不支持高并发,Nginx能支持处理百万级的TC			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ybjlxnp.html" rel="bookmark">Fireworks MX 2004新功能色彩替换详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				详解 在Macromedia官方的宣传中,有十个推荐的Fireworks MX 2004的新功能,其中有一个是Replace Color Tool.实话说,在拿到新版的Fireworks时,这个功能没有引起我的注意,粗略的看它和4.0版本的擦除工具有些相似.但细细使用之后,它的功能有些令我吃惊,他可以做的不仅仅是位图的色彩替换,更进一步,它还可以改变图片的主色调,替换背景色,还有一个更重要的是利用它可以进行扣图的操作.下面就来看看他的这几大主要功能. 首先我们打开一张美女图,我们将要利用这个美女			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/LpdDDmp.html" rel="bookmark">PHP脚本数据库功能详解（3）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				脚本|数据|数据库|详解 (作者:王凯波) 用类加快PHP的数据库开发 数据库的访问函数较多,使用不当会降低效率,甚至导致错误.而PHP的本身就是开放的和可扩充的,很多人为它开发各种功能的源代码.每一个PHP程序员都应该善于继承他人的成果,节省时间和精力.站在巨人的肩膀上,才能看得更远.当然,你也可以把你的代码共享出来,体会自己的劳动被承认和创造价值而带来的成就感. 使用数据库类,可以使我们完全不必考虑具体的数据库类型,而专注于程序的开发上. 众多的开发工具包中,PHPLib是性能较稳定.功能较			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0bo8yjM.html" rel="bookmark">PHP 脚本数据库功能详解（上）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				脚本|数据|数据库|详解 在当前互联网发展迅速.电子商务网站层出不穷的形势下,对网站开发 的效率和质量提出了越来越高的要求. 对于大型和结构复杂.内容繁多的网站,都要实现网站的动态化和 方便的管理.数据管理离不开数据库系统的支持.而衡量一种CGI语言的 重要标志,就是它对后台数据库的访问能力.效率等. 而目前流行的PHP脚本语言,它的新特性给我们带来了新的感觉.它支持以面向对象的方 式进行设计开发.同时,为了满足网页独特的需要,用模板.XML支持等带来了网站开发的新 方法.在语言结构上,PHP具			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/qbaYnqb.html" rel="bookmark">PHP脚本数据库功能详解（1）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				脚本|数据|数据库|详解 (作者:王凯波) 在当前互联网发展迅速.电子商务网站层出不穷的形势下,对网站开发的效率和质量提出了越来越高的要求. 对于大型和结构复杂.内容繁多的网站,都要实现网站的动态化和方便的管理.数据管理离不开数据库系统的支持.而衡量一种CGI语言的重要标志,就是它对后台数据库的访问能力.效率等. 而目前流行的PHP脚本语言,它的新特性给我们带来了新的感觉.它支持以面向对象的方式进行设计开发.同时,为了满足网页独特的需要,用模板.XML支持等带来了网站开发的新方法.在语言结构上,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/rz4GkJp.html" rel="bookmark">flash关于字体元件与字符嵌入等功能详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				详解 ========上篇======== flash的优点之一就是能够使用各种各样的字体,而传统的HTML要使用各种各样非系统默认的字体只有两种办法 1,是将特殊字体嵌入到浏览器中,可惜这一功能不仅仅体积巨大而且并不是对于所有浏览器都适用.(英文字体倒只有百来K但是中文字体起码都1M以上)这样的办法对于中文来说显然是不现实的2,是将所用到特殊字体的地方都做成图片,这样的好处是任何平台浏览器显示效果都是一致的.但是缺点也是明显的,首先修改不容易,即使是最细微的修改也需要用专门的图形编辑软件来修改			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5A176p.html" rel="bookmark">快人一步&mdash;&mdash;傲游3 &OpenCurlyDoubleQuote;快应用&rdquo;功能详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  当上网不仅仅是看网页时,用户对浏览器的要求也越来越高.打破传统思维,提供创新性功能已经迫在眉睫.5月10日,傲游3.0.23.1000新版发布,加入了独树一帜的&quot;快应用&quot;功能.通过这个功能,用户可一键直达心爱网站,无需打开浏览器,更不要谈打开收藏.输入网址等繁琐操作,简单快捷. 保存网页为快应用 &quot;快应用&quot;功能使用简单,只需在标签上点击右键,选择&quot;保存为快应用&quot;选项,在弹出的对话框中完善信息,点击确定即可生成一个快应用. 图一 这一步也可以通			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M08YPM.html" rel="bookmark" class="title">CSS定义1px高度的div</a>
					<div>
						div.lihe{ font-size:1px; line-height:1px; height:1px;} 这个应用的比较多的就是火狐浏览器的清除浮动: .clear{clear:both; fon ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVnwKQz.html" rel="bookmark" class="title">数据挖掘的研究现状</a>
					<div>
						一.时代的挑战 近十几年来,人们利用信息技术生产和搜集数据的能力大幅度提高,无数个数据库被用于商业管理.政府办公.科学研究和工程开发等,这一势头仍将持续发展下去.于是,一个新的挑战被提了出来:在这被称 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6wWVz.html" rel="bookmark" class="title">WPS制作带斜线表头的表格</a>
					<div>
						  如何用WPS制作带斜线表头的表格 ·斜线表头 金山文字可以方便地生成带有斜线的表头,方法是: 光标定位在需要设置斜线的单元格中. 执行[表格][绘制斜线表头]命令,打开如图2-24所示的[斜线单元 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEWOOAp.html" rel="bookmark" class="title">使用Win7系统过程中我们经常会犯的三个错误操作</a>
					<div>
						  1.杀毒软件的安装 我们在入手一款win7系统的时候,并没有必要在第一时间安装杀毒软件,如果一些简单的因为win7用户误操作引发的win7故障,直接启动win7内置修复软件就可以解决,杀毒软件有可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnYoBjM.html" rel="bookmark" class="title">新浪微博如何在企业版主页添加投票模块？</a>
					<div>
						  投票应用已经上线,可以在管理首页-我的应用-应用广场中选择名为&quot;投票调研 &quot;的应用进行使用. 该应用可以发起文字投票:最多可设置20个投票选项;发起图片投票:最多可设置15个投 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b240lQp.html" rel="bookmark" class="title">USBDeview是做什么用的</a>
					<div>
						  有些时候我们想了解U盘的一些信息,比如设备添加的日期以及最后连接的日期等,现在就为您 介绍一款工具--USBDeview. USBDeview是一款小巧免费的USB设备检测和管理工具,功能颇为强大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwLorRb.html" rel="bookmark" class="title">linux常用命令加实例大全</a>
					<div>
						目  录引言    1一.安装和登录    2(一)    login    2(二)    shutdown    2(三)    halt    3(四)    reboot    3(五)    ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0WJe0b.html" rel="bookmark" class="title">Hadoop学习资源集合</a>
					<div>
						Hadoop是一个由Apache基金会所开发的开源分布式系统基础架构.用户可以在不了解分布式底层细节的情况下,开发分布式程序,充分利用集群的威力进行高速运算和存储.Hadoop得以在大数据处理应用中广 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq849Gb.html" rel="bookmark" class="title">fastcgi安装</a>
					<div>
						fastcgi安装 这里及以下的web服务器都是以nginx为例子和说明,php以5.3为例子. php-fpm fastcgi在服务器上会启动多个进程进行解析,这个时候就需要一个fastcgi的管理 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPkPDp.html" rel="bookmark" class="title">spring mvc-springmvc controller Mapping不能和方法Mapping一样&quest;</a>
					<div>
						问题描述 springmvc controller Mapping不能和方法Mapping一样? 方法名一样就404了,不一样就可以找到,为什么?如/goods/goods就不行,改为/goods/g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXwxNvM.html" rel="bookmark" class="title">为什么要用-all&lowbar;load&amp;amp&semi;-ObjC</a>
					<div>
						为了减少工作量复用部分代码,于是乎我们开始选择重构整个项目,把可以公用的代码放在一起打包成一个 静态库子项目在其他的项目中使用.介绍这部分内容的文章在网上很多,各位可以G一下细看. 但是每次在加入静态 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvrJo1M.html" rel="bookmark" class="title">maven项目有关接口问题</a>
					<div>
						问题描述 maven项目有关接口问题 我有一个maven项目,已开发完成,可是今天经理说要改成接口的方式,我不太明白这是什么意思,还有该如何实现呢,急求!!! 解决方案 maven项目问题构建Mave ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7YBo5M.html" rel="bookmark" class="title">test luadbi&amp;&num;039&semi;s postgresql driver performance &lpar;vs pgbench&rpar;</a>
					<div>
						测试机环境 :  Lua 5.1.5 CentOS 5.7 x64 PostgreSQL 9.3.2 CPU model name : Intel(R) Xeon(R) CPU E5440 @ 2.8 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOlxLkb.html" rel="bookmark" class="title">服务器-公众微信接入配置在百度BCC上的接口</a>
					<div>
						问题描述 公众微信接入配置在百度BCC上的接口 公众微信验证接口的要求是正确返回用GET方式发送的echostr,我直接把index.php写成了: &lt;?php echo $_GET['echo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkwoVyp.html" rel="bookmark" class="title">javascript-nvelocity中的&num;if&lpar;&rpar;如何在JavaScript中使用？</a>
					<div>
						问题描述 nvelocity中的#if()如何在JavaScript中使用? nvelocity中的if跟JavaScript中的if关键字冲突了,怎么想办法可以用nvelocity中的#if &lt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeRL78b.html" rel="bookmark" class="title">从&OpenCurlyDoubleQuote;扫月亮&rdquo;到&OpenCurlyDoubleQuote;扫福字&rdquo;，扒一扒背后的支付宝AR框架体系</a>
					<div>
						以下内容根据红包技术峰会直播视频以及演讲PPT整理而成.视频请点击这里 承智关于支付宝AR框架体系和实践的分享主要分为以下三个部分: 支付宝AR框架体系 AR实践案例分享 总结和展望 在本次分享中,来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKWeNb.html" rel="bookmark" class="title">iOS开发UI篇&mdash;Quartz2D使用（矩阵操作）</a>
					<div>
						一.关于矩阵操作 1.画一个四边形 通过设置两个端点(长和宽)来完成一个四边形的绘制. 代码: 1 - (void)drawRect:(CGRect)rect 2 { 3 //画四边形 4 //获取图 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3rjJ0z.html" rel="bookmark" class="title">d3 js-D3js svg 画一个发光的圆点</a>
					<div>
						问题描述 D3js svg 画一个发光的圆点 刚开始学d3不熟悉,麻烦大牛们用帮我画一个光点就可以了,就像 http://map.ipviking.com/网站上的光点一样,谢谢 解决方案 http: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z40GjYz.html" rel="bookmark" class="title">服务器-求大神指点，android登陆和社区类点赞的过程</a>
					<div>
						问题描述 求大神指点,android登陆和社区类点赞的过程 android客户端登陆和点赞时是怎么与服务器交互的,传给服务器什么数据,服务器又返回什么? 解决方案 服务端提供http接口,你直接调用, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKrddb.html" rel="bookmark" class="title">大规模存储的未来&mdash;&mdash;内存云</a>
					<div>
						计算机系统中最快的存储方式是传统上主要用作内存的RAM.由于硬盘的访问性能多年来有恶化的趋势,而RAM的成本不断降低,近年来,有很多研究者都在探索如何用内存取代硬盘. 早在1980年代,David D ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLQr8M.html" rel="bookmark" class="title">关于环信2&period;2&period;5iOS版支持ipv6的问题</a>
					<div>
						问题描述 最近替程序更换环信2.2.5的sdk,在ipv6环境下测试登录时使用[[EaseMob sharedInstance].chatManager asyncLoginWithUsername: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnREVjp.html" rel="bookmark" class="title">Web&period;config打开出的是图形界面</a>
					<div>
						问题描述 Web.config打开出的是图形界面,而不是代码界面,我右击每种方式都试着打开一次,可以出来但是代码不出提示这怎么解决? 解决方案 解决方案二:没见过web.config的图形界面张什么样 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnPA6M.html" rel="bookmark" class="title">pc端用java swing写界面不大美观，如果想实现下图的界面效果，可以用什么写界面实现</a>
					<div>
						问题描述 pc端用java swing写界面不大美观,如果想实现下图的界面效果,可以用什么写界面实现 解决方案 这个不是JAVA的强项. 不过AWT 可以试试看 解决方案二: jsp html 都可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MR1qwxb.html" rel="bookmark" class="title">Hadoop增速加快 专业人才现巨大缺口</a>
					<div>
						在快速增长的Hadoop数据分析软件市场,供应与需求并没有实现同步.与雇用IT人才创建和维护分布式计算系统相比,公司部署Hadoop的速度更为迅速.为了填补出现的缺口,许多公司开始转向与能够提供Had ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3Z81Wz.html" rel="bookmark" class="title">jQuery的bind&lpar;&rpar;方法使用详解&lowbar;jquery</a>
					<div>
						bind()方法用法详解: 此方法是使用比较频繁的方法之一,虽然在API手册上有着对方法的介绍,但是由于语言简短,例子不够详细,可能会造成不能够完全准确的掌握bind()方法的使用,下面就结合实例介绍 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgEee3z.html" rel="bookmark" class="title">javascript 表格内容排序 简单操作示例代码&lowbar;javascript技巧</a>
					<div>
						复制代码 代码如下: &lt;div id=&quot;html&quot;&gt;&lt;/div&gt; &lt;script&gt; var listInfos = new Array(); l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z44B7Pz.html" rel="bookmark" class="title">flash进度条</a>
					<div>
						&lt;script language=&quot;JavaScript&quot;&gt;         &lt;!--         var nTimeoutId = setTimeout(' ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVd71DM.html" rel="bookmark" class="title">惠普高管称PC业务价值远超年销售额1&sol;4</a>
					<div>
						新浪科技讯 北京时间8月24日早间消息,惠普负责PC业务的执行副总裁托德·布拉德利(Todd Bradley)表示,惠普PC业务部门的价值超过该公司年销售额的1/4.惠普上周进行战略挑战,有可能将分拆 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXdRrKp.html" rel="bookmark" class="title">安全走向开放 建安全架构协同互联生态体系</a>
					<div>
						随着联网设备的增加,安全威胁的来源变得更为广泛.预计到2019年连网设备达到200多亿,而这些联网设备的类型也将更加多样性.大量智能终端访问企业内部数据的需求,以及移动办公.BYOD的兴起,对于企业安 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn4o2rb.html" rel="bookmark" class="title">Mongodb增加、移除Arbiter节点实例&lowbar;MongoDB</a>
					<div>
						增加Arbiter 增加配置文件mongod1,mongod2,mongod3分别为shard1,shard2,shard3三个set集合的arbiter. 复制代码 代码如下: replSet=sh ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.025 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
